"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.analyzeDeps = void 0;
const babel = __importStar(require("@babel/core"));
const traverse_1 = __importDefault(require("@babel/traverse"));
const types = __importStar(require("@babel/types"));
const compiler = __importStar(require("@vue/compiler-sfc"));
const utils_1 = require("@vuepress/utils");
const module_resolver_1 = require("./module-resolver");
function analyzeDeps(absoluteFilePath) {
    var _a, _b;
    let content = utils_1.fs.readFileSync(absoluteFilePath, 'utf-8');
    if (/\.vue$/.test(absoluteFilePath)) {
        const { descriptor } = compiler.parse(content);
        content = (((_a = descriptor === null || descriptor === void 0 ? void 0 : descriptor.script) === null || _a === void 0 ? void 0 : _a.content) ||
            ((_b = descriptor.scriptSetup) === null || _b === void 0 ? void 0 : _b.content));
    }
    // @ts-ignore
    const ast = babel.transformSync(content, {
        ast: true,
        plugins: [require('@babel/plugin-syntax-jsx')],
    }).ast;
    const dependencies = [];
    const addDep = function (requireStr) {
        const absPath = (0, module_resolver_1.getModuleResolvePath)({
            basePath: absoluteFilePath,
            sourcePath: requireStr,
        });
        if (!absPath || absPath.includes('node_modules')) {
            return;
        }
        dependencies.push(absPath);
    };
    (0, traverse_1.default)(ast, {
        CallExpression(callPath) {
            const callPathNode = callPath.node;
            // traverse all require statement
            if (types.isIdentifier(callPathNode.callee) &&
                callPathNode.callee.name === 'require' &&
                types.isStringLiteral(callPathNode.arguments[0])) {
                addDep(callPathNode.arguments[0].value);
            }
        },
        ImportDeclaration(path) {
            addDep(path.node.source.value);
        },
    });
    return dependencies;
}
exports.analyzeDeps = analyzeDeps;
